<?php
/**
 * CLink License Media
 *
 * CLink license media
 *
 * @package CLink
 * @subpackage System
 */
 
// Direct Access Not Allowed
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
/**
 * CLink Display Showcase for Image
 *
 * @param integer attachment_id attachment id
 * @return string html
 */
function wpclink_display_image_showcase($attachment_id = 0){
	$image_url = wp_get_attachment_url($attachment_id);
	return '<img src="'.$image_url.'" class="img showcase" data-clink-media-license="1" />';
}
/**
 * CLink Display Showcase for all Medias
 *
 * @param integer attachment_id attachment id
 * @return string html
 */
function wpclink_display_media_showcase($attachment_id = 0){
	$type = get_post_mime_type($attachment_id);
	switch ($type) {
    case 'image/jpeg':
		return wpclink_display_image_showcase($attachment_id);
    case 'image/png':
    case 'image/gif':
    case 'video/mpeg':
    case 'video/mp4': 
    case 'video/quicktime':
    case 'text/csv':
    case 'text/plain': 
    case 'text/xml':
    default:
  }
}
/**
 * CLink Reuse Offer Popup
 * 
 * @param integer attachment_id attachment id
 */
function wpclink_do_popup_link_media($attachment_id = 0) {
	// If import mode only
	if(wpclink_import_mode()) return false;
	// if content is not in linked list
	if(wpclink_is_post_referent($attachment_id)){
		// OK
	}else{
		return false;
	}
	$token = uniqid();
?>
<div id="CLModal" class="cl_modal">
  <div class="cl_modal-content">
    <span class="cl_close">&times;</span>
<form id="cl_new_offer_clinkid" action="" style="display:block">
<div id="cl_offer_response" style="display:block">
<p class="style4" ><?php _e('The reuse of this content is enabled for WordPress powered sites using ','cl_text'); ?><a class="cl_hyperlink" target="_blank" href="https://wordpress.org/plugins/wpclink/">wpCLink</a> plugin.</p>


<p class="description style2"><?php _e('Please Log Into your WordPress Instance','cl_text'); ?></p>
<input id="cl_weburl" required="required" value="" autofocus="autofocus" placeholder="https://mydomain.com" type="url">
<p class="style1"><?php _e('The content will be accessible at the Creations &rarr; Linked menu  in your WordPress instance after you accept the Terms and Conditions of the License.','cl_text'); ?></p>
<input type="hidden" id="cl_popup_id" value="<?php echo $token; ?>" />
<div class="quick-response"></div>
<?php /* <p class="divider-or"><span>or</span></p>
 <p><a class="go_care"><span class="cico"></span>Sign In with CLink</a></p> */ ?>
<input style="visibility:hidden" class="content_type" type="checkbox" name="content_type" checked="checked" value="single" />
<input type="hidden" name="cl_auto_code" id="cl_auto_code" value="" />

<?php if ( $group_found = wpclink_get_option('wpclink_group') ) {
if(!empty($group_found['url'])){ ?>
<p class="style3"><a class="additional-btn" href="#"><strong>+</strong> <?php _e('Available Options','cl_text'); ?></a></p>
<div class="additional_option">
<ul>
  <li>
    <label class="container_check"><?php _e('Join Group','cl_text'); ?>
  <input class="content_type" type="checkbox" name="content_type" value="group">
  <span class="checkmark"></span>
</label>
  </li>
</ul>
</div>
<?php }
} ?>
<div id="wait"></div>
<input id="cl_modal_submit" value="Get a license" type="submit">
</div>
</form>		
    <input type="hidden" name="auto_content" id="auto_content" value="<?php echo $attachment_id ?>" />
	<p class="style3"><a target="_blank" href="https://licenses.clink.id/personal/0-9i/"><?php _e('License Terms and Conditions','cl_text'); ?> <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><rect x="0" fill="none" width="20" height="20"/><g><path d="M9 3h8v8l-2-1V6.92l-5.6 5.59-1.41-1.41L14.08 5H10zm3 12v-3l2-2v7H3V6h8L9 8H5v7h7z"/></g></svg></a></p>
</div>
</div>
<?php }
// Register clink reuse offer popup function
add_action( 'wpclink_media_footer', 'wpclink_do_popup_link_media',10,1 );

/**
 * CLink Load License
 * 
 */
function wpclink_load_license(){
	
$media_id = $_GET['id'];
	
if (is_numeric($media_id)) {
    if($media_id == 0){
			die('ERROR: 404 Not Found');
	}else{
	}
} else {
    die('ERROR: 400 Invalid Command');
}

// Style
$style_showcase = plugins_url('public/css/media-showcase.css?'.uniqid('_'),dirname(__FILE__));
$style_frontend = plugins_url('public/css/frontend.css?'.uniqid('_'),dirname(__FILE__));
$style_modal = plugins_url('public/css/modal.css?'.uniqid('_'),dirname(__FILE__));
	
$styles_list = array($style_showcase,
					 $style_frontend,
					 $style_modal);
$stylesheet = '';
foreach($styles_list  as $style_signle){
	$stylesheet .='<link href="'.$style_signle.'" rel="stylesheet">';	
}

	
// CLink ID
if($contentID = get_post_meta( $media_id, 'wpclink_creation_ID', true )){
	$content_url = WPCLINK_ID_URL.'/#objects/'.$contentID;		
}
	
$archive_tr = '';

// Created DAte
$get_post_date  = get_the_date('Y-m-d',$media_id);
$get_post_date .= 'T';
$get_post_date .= get_the_date('G:i:s',$media_id);
$get_post_date .= 'Z';
$created_time = $get_post_date;
	
// Get Last Archive if has
$archive_link = wpclink_get_last_archive($media_id);
if(!empty($archive_link)){
	
$thumbnail_src =  wp_get_attachment_image_src( $media_id, 'medium' );

$archive_tr = '<div class="cl-arhive-box"><a class="archive_thumbnail" target="_blank" href="'.$archive_link.'" style="background-image:url('.$thumbnail_src[0].')"><span class="archive-icon-big"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><rect x="0" fill="none" width="20" height="20"/><g><path d="M13.65 2.88c3.93 2.01 5.48 6.84 3.47 10.77s-6.83 5.48-10.77 3.47c-1.87-.96-3.2-2.56-3.86-4.4l1.64-1.03c.45 1.57 1.52 2.95 3.08 3.76 3.01 1.54 6.69.35 8.23-2.66 1.55-3.01.36-6.69-2.65-8.24C9.78 3.01 6.1 4.2 4.56 7.21l1.88.97-4.95 3.08-.39-5.82 1.78.91C4.9 2.4 9.75.89 13.65 2.88zm-4.36 7.83C9.11 10.53 9 10.28 9 10c0-.07.03-.12.04-.19h-.01L10 5l.97 4.81L14 13l-4.5-2.12.02-.02c-.08-.04-.16-.09-.23-.15z"/></g></svg></a></span></div>';
	
}
// Version CLink ID(s)
if($clink_versions = get_post_meta( $media_id, 'wpclink_versions', true )){
	if(is_array($clink_versions)){
		$versions = '<tr><td width="40%">Versions</td><td class="cl-value" width="60%">'.count($clink_versions).'</td></tr>';
	}
}
// Right Holder
if($rights_holder_id = get_post_meta( $media_id, 'wpclink_rights_holder_user_id', true )){
	// Display Name
	$creator_user_data = get_userdata($rights_holder_id);
	$creator_user_display = $creator_user_data->display_name;
}
// Right ID
if($wpclink_right_ID = get_post_meta( $media_id, 'wpclink_right_ID', true )){

$right_ID_url = WPCLINK_ID_URL.'/#objects/'.$wpclink_right_ID;

	
if($right_created_time = get_post_meta( $media_id, 'wpclink_right_created_time', true )){
	$created_time_right = $right_created_time;
}

if(!empty($created_time_right)){
	$right_tr = '<div class="cl-title">
	<h3>Rights</h3>
	</div>
	<table cellspacing="0" cellpadding="0"><tbody><tr><td class="cl-strong" width="40%">Declared at</td>
	<td class="cl-value" width="60%">'.$created_time_right.'<a href="'.$right_ID_url.'" class="external" target="_blank"></a></td>
	</tr><tr></tr></tbody></table>';
}
	
}
?><!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<?php echo $stylesheet; ?>
<?php wp_head(); ?>  
</head>
<body class="custom-background-image">
<div class="media-container">
<div id="media"><?php echo wpclink_display_media_showcase($media_id) ?></div>
<?php if(!empty($contentID)){ ?>
<div id="reuse" class="clink-imagebox"><ul class="cl-info-menu"><li class="cl-info" id="mode-60465a674f04c">
<span class="cl-info-icon" role="button" tabindex="0"><svg id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 512 512" style="background:0 0"><g><g><path style="fill:#fff" d="M437.02 74.98C388.667 26.629 324.38.0 256 0S123.333 26.629 74.98 74.98C26.629 123.333.0 187.62.0 256s26.629 132.667 74.98 181.02C123.333 485.371 187.62 512 256 512s132.667-26.629 181.02-74.98C485.371 388.667 512 324.38 512 256S485.371 123.333 437.02 74.98zM256 101c24.813.0 45 20.187 45 45s-20.187 45-45 45-45-20.187-45-45S231.187 101 256 101zm64 3e2H190v-30h21V251h-20v-30h110v150h19v30z"/></g></g><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/><g/></svg></span>
<span class="cl-darkmode-icon" id="nightmode_btn-60465a674f04c" role="button" tabindex="0"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><title></title><path d="M20.21,15.32A8.56,8.56,0,1,1,11.29,3.5a.5.5,0,0,1,.51.28.49.49,0,0,1-.09.57A6.46,6.46,0,0,0,9.8,9a6.57,6.57,0,0,0,9.71,5.72.52.52,0,0,1,.58.07A.52.52,0,0,1,20.21,15.32Z" fill="#ffff"></path></svg></span>
<ul class="cl-subitem" id="cl-media-popup-60465a674f04c"><div class="cl-media-popup scrollbar style-1">
<div class="cl-wrapper">
<div class="cl-body">
<table cellspacing="0" cellpadding="0" class="signer-info">
<tbody><tr><td>Recorded by </td><td class="cl-value sign-logo-wrapper" width="60%"><span class="sign-logo"></span> CLink Media</td></tr><tr><td>Recorded at</td><td class="cl-value" width="60%"><?php echo $created_time; ?><a href="<?php echo $content_url; ?>" class="external" target="_blank"></a></td></tr>
</tbody>
</table>
<?php if($origin_versions > 0 || !empty ($archive_link) || !empty($sync_origin)){ ?>
<div class="cl-title">
<h3>Provenance</h3>
</div><table cellspacing="0" cellpadding="0"><tbody><?php if(!empty($sync_origin)) { ?><tr><td class="cl-strong" width="40%">Published at</td>
<td class="cl-value" width="60%"><?php echo $created_time; ?> <a target="_blank" href="<?php echo $content_url; ?>" class="external"></a></td>
</tr><?php } ?> <?php echo $versions; ?></tbody></table><?php echo $archive_tr; ?><?php } ?><?php echo $right_tr; ?></div>
</div>
</div>
</ul></li></ul><?php echo wpclink_media_reuse_button(); ?> </div> 
<?php } ?>
</div><?php do_action('wpclink_media_footer',$media_id); ?>
<?php wp_footer(); ?>  
</body>
</html><?php
}

/**
 * CLink Media License URL
 * 
 */
function wpclink_start_media_license(){
		if(isset($_GET['clink_media_license'])){
			wpclink_load_license();
			die();
		}
}
// Register generate xml url function on wordpress load
add_action('wp_loaded','wpclink_start_media_license');
